#!/bin/bash
#Keep this line (these two unix lines) unchanged
# Copyright (c) 2010 by Emin Gabrielyan of switzernet.com
# Created and modified on 2010-12-28 by Emin
# Version: aa04
#
# fraud-control:~/folders/101228-radius# crontab -l
# m h  dom mon dow   command
# */1 * * * * cd /root/folders/101228-radius/; cp Download/run.sh .; chmod a+x run.sh; ./run.sh 2>> err.log >> std.log
# fraud-control:~/folders/101228-radius#
                                                                         #
work="`pwd`"                                                             #
cd $work                                                                 #
                                                                         #
connect="`cat connect.txt`"                                              #
far_running=/var/log/porta-billing.log                                   #
far_rotated="/var/log/porta-billing.log.?"                               #
rewind=11000                                                             #
                                                                         #
function download                                                        #
{                                                                        #
  cd $work                                                                 #
  url1="http://parinternet.ch/2/public/101228-radius-log/ver/download.zip" #
  url2="http://switzernet.com/3/public/101228-radius-log/ver/download.zip" #
  url3="http://unappel.ch/2/public/101228-radius-log/ver/download.zip"     #
  url4="http://www.unappel.ch/2/public/101228-radius-log/ver/download.zip" #
  ok=1                                                                     #
  for((i=1;i<=2;i++))                                                      #
  do                                                                       #
    wget -t 1 -N $url1 && break                                              #
    wget -t 1 -N $url2 && break                                              #
    wget -t 1 -N $url3 && break                                              #
    wget -t 1 -N $url4 && break                                              #
    [ $i -eq 5 ] && ok=0                                                     #
  done                                                                     #
  rm -r Download 2>/dev/null                                               #
  [ -f download.zip ] && unzip -o download.zip -d Download                 #
}                                                                        #
                                                                         #
                                                                         #
                                                                         #
function error                                                           #
{                                                                        #
  msg=$1                                                                 #
  date +%Y-%m-%d,%H:%M:%S,"$msg" | tee -a error.log                      #
  mv status=busy,lock.log status=free,lock.log                           #
  exit 1                                                                 #
}                                                                        #
                                                                         #
function createifnone                                                    #
{                                                                        #
  if [ ! -f ??????,??????,*,*,running,radius.log ]                         #
  then                                                                     #
    exe="f=$far_running; ls -i \$f; wc -c \$f"                               #
    info=`$connect "$exe" 2> /dev/null | awk '{printf ",%s",$1}'`            #
    if [ -z "$info" ]                                                        #
    then error "Error getting remote info"                                   #
    fi                                                                       #
    inode=`echo $info | cut -d, -f2`                                         #
    size=`echo $info | cut -d, -f3`                                          #
    if [ $size -gt $rewind ]                                                 #
    then size=$((size-rewind))                                               #
    else size=0                                                              #
    fi                                                                       #
    cp /dev/null `date +%y%m%d,%H%M%S,$inode,$size,running,radius.log`       #
  fi                                                                       #
}                                                                        #
                                                                         #
                                                                         #
function logsync                                                         #
{                                                                        #
  local=??????,??????,*,*,running,radius.log                               #
  fdate=`echo $local | cut -d, -f1`                                        #
  ftime=`echo $local | cut -d, -f2`                                        #
  inode=`echo $local | cut -d, -f3`                                        #
  head=`echo $local | cut -d, -f4`                                         #
  set 1 `wc -c $local`                                                     #
  size=$2                                                                  #
  skip=$((head+size))                                                      #
  exe1="set 1 \`ls -i $far_running $far_rotated | egrep ^$inode\\ \`;"     #
  exe2=" f=\$3; [ ! -z \"\$f\" ] &&"                                       #
  exe3=" echo \$f >&2 && dd bs=1 skip=$skip if=\$f"                        #
  far_file=`$connect "$exe1$exe2$exe3" 2>&1 >> $local`                     # Standard output goes to file, error output is captured (att: swapping of positions will change all)
  if [ -z "$far_file" ]                                                    #
  then error "Error finding the far inode"                                 #
  fi                                                                       #
  echo "$far_file" | while read s                                          #
  do date +%Y-%m-%d,%H:%M:%S,"$s"                                          #
  done | tee -a standard.log                                               #
  if [ ! $far_running = `echo "$far_file" | head -1` ]                     #
  then mv $local $fdate,$ftime,$inode,$head,rotated,radius.log             #
  fi                                                                       #
}                                                                        #
                                                                         #
                                                                         #
                                                                         #
function checkfolder                                                     #
{                                                                        #
  n=`ls ??????,??????,*,*,running,radius.log 2>/dev/null | wc -l`          #
  if [ $n -gt 1 ]                                                          #
  then error "Error with running files"                                    #
  fi                                                                       #
}                                                                        #
                                                                         #
                                                                         #
                                                                         #
function run                                                             #
{                                                                        #
  cd /var/log/radius                                                       #
  ls status=*,lock.log > /dev/null 2>&1 ||                                 #
  cp /dev/null status=free,lock.log                                        #
  if mv status=free,lock.log status=busy,lock.log 2>/dev/null              #
  then                                                                     #
    date +%Y-%m-%d,%H:%M:%S,"pid=$$" | tee -a status=busy,lock.log           #
    for((i=1;i<=30;i++))                                                     #
    do                                                                       #
      checkfolder                                                              #
      createifnone                                                             #
      logsync                                                                  #
      sleep 10                                                                 #
    done                                                                     #
    mv status=busy,lock.log status=free,lock.log                             #
  else                                                                     #
    msg="Locked since `tail -1 status=busy,lock.log`"                        #
    date +%Y-%m-%d,%H:%M:%S,"$msg" | tee -a error.log                        #
  fi                                                                       #
}                                                                        #
                                                                         #
                                                                         #
                                                                         #
run                                                                      #
download                                                                 #
exit                                                                     #
                                                                         #
                                                                         #
                                                                         #
                                                                         #